## findlib 1.5.5

=== Makefile ===
# make all: compile to bytecode
# make opt: compile to native code
# make install: install bytecode and/or native code
#----------------------------------------------------------------------

include Makefile.config

TOP=.

.PHONY: all opt install uninstall clean

all:
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) all ) || exit; done
	$(MAKE) all-config

opt:
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) opt ) || exit; done

install:
	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
	mkdir -p "$(prefix)$(OCAMLFIND_MAN)"
	$(MAKE) install-config
	for p in $(PARTS); do ( cd src/$$p; $(MAKE) install ); done
	$(MAKE) install-meta
	cd src/findlib; $(MAKE) install-num-top
	if [ $(INSTALL_CAMLP4) -eq 1 ]; then \
		cp tools/safe_camlp4 "$(prefix)$(OCAMLFIND_BIN)"; \
	fi
	$(MAKE) install-doc

uninstall:
	$(MAKE) uninstall-doc
	$(MAKE) uninstall-meta
	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) uninstall ); done
	$(MAKE) uninstall-config

clean:
	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) clean ); done
	(cd itest-aux; $(MAKE) clean)
	(cd tools/extract_args; $(MAKE) clean)
	rm -f findlib.conf

.PHONY: release
release: README
	./release

README: doc/README
	ln -s doc/README .


.PHONY: all-config
all-config: findlib.conf

findlib.conf: findlib.conf.in
	USE_CYGPATH="$(USE_CYGPATH)"; \
	export USE_CYGPATH; \
	cat findlib.conf.in | \
		tools/patch '@SITELIB@' '$(OCAML_SITELIB)' >findlib.conf
	if ocamlc.opt >/dev/null 2>&1; then \
		echo 'ocamlc="ocamlc.opt"' >>findlib.conf; \
	fi
	if ocamlopt.opt >/dev/null 2>&1; then \
		echo 'ocamlopt="ocamlopt.opt"' >>findlib.conf; \
	fi
	if ocamldep.opt >/dev/null 2>&1; then \
		echo 'ocamldep="ocamldep.opt"' >>findlib.conf; \
	fi
	if ocamldoc.opt >/dev/null 2>&1; then \
		echo 'ocamldoc="ocamldoc.opt"' >>findlib.conf; \
	fi

.PHONY: install-doc
install-doc:
	mkdir -p $(prefix)$(OCAMLFIND_MAN)/man1 $(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5
	-cp doc/ref-man/ocamlfind.1 $(prefix)$(OCAMLFIND_MAN)/man1
	-cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 $(prefix)$(OCAMLFIND_MAN)/man5

.PHONY: uninstall-doc
uninstall-doc:
	rm -f $(prefix)$(OCAMLFIND_MAN)/man1/ocamlfind.1
	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Findlib.3
	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Topfind.3
	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/META.5
	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/site-lib.5


.PHONY: install-meta
install-meta:
	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" -a -f "site-lib-src/$$x/META" ]; then mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done

.PHONY: uninstall-meta
uninstall-meta:
	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" ]; then rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done

.PHONY: install-config
install-config:
	mkdir -p "`dirname \"$(prefix)$(OCAMLFIND_CONF)\"`"
	@if [ -f "$(prefix)$(OCAMLFIND_CONF)" ]; then echo "!!! Keeping old $(prefix)$(OCAMLFIND_CONF) !!!"; fi
	test -f "$(prefix)$(OCAMLFIND_CONF)" || cp findlib.conf "$(prefix)$(OCAMLFIND_CONF)"

.PHONY: uninstall-config
uninstall-config:
	@echo Leaving "$(OCAMLFIND_CONF)" installed, consider manual removal

.PHONY: interface-lists
interface-lists:
	d=`ocamlc -where`;                              \
	for x in `ls site-lib-src`; do                  \
	    iflist="";                                  \
            if [ ! -f "site-lib-src/$$x/interfaces.in" ]; then continue; fi; \
	    cma_spec=`cat site-lib-src/$$x/interfaces.in`;  \
	    for cma in $$d/$$cma_spec; do               \
		intf=`ocamlobjinfo $$cma |                   \
		      grep 'Unit name:' |               \
		      sed -e 's/^  Unit name: //' |     \
		      sort |                            \
		      tr '\n' ' '`;                     \
		iflist="$$iflist $$intf";               \
	    done;                                       \
	    echo "$$iflist" >"site-lib-src/$$x/interfaces.out"; \
	done

######################################################################
# The following is from Pietro Abata <pietro.abate@anu.edu.au>
# to create MacOS X packages. I did not test it, just include it.

.PHONY: package-macosx

package-macosx: all opt
	mkdir -p package-macosx/root
	export prefix=`pwd`/package-macosx/root && make install
	export VERSION=1.1.2 && tools/make-package-macosx

clean-macosx:
	sudo rm -rf package-macosx

=== itest-aux/Makefile ===
all:

clean:
	rm -f simple simple.exe *.cmi *.cmo *.cma *.cmx *.o *.a
	rm -f err.out
	rm -f testdb*

=== src/bytes/Makefile ===
BYTE_FILES=bytes.cmi bytes.cma
NATIVE_FILES=bytes.cmx bytes.a bytes.cmxa
NATIVE_FILES_DYNLINK=bytes.cmxs
OCAMLBUILD=ocamlbuild -classic-display -no-links

TOP=../..
include $(TOP)/Makefile.config

build: all opt

all:
	$(OCAMLBUILD) $(BYTE_FILES)

opt:
	files="$(NATIVE_FILES)"; \
	if [ $(HAVE_NATDYNLINK) = 1 ]; then \
	    files="$$files $(NATIVE_FILES_DYNLINK)"; \
	fi; \
	$(OCAMLBUILD) $$files

install: all
	mkdir -p "$(prefix)$(OCAML_SITELIB)/bytes"
	cd _build/ && cp ../META $(BYTE_FILES) "$(prefix)$(OCAML_SITELIB)/bytes"
	cd _build/ && for f in $(NATIVE_FILES) $(NATIVE_FILES_DYNLINK); do if [ -f "$$f" ]; then cp $$f "$(prefix)$(OCAML_SITELIB)/bytes"; fi; done

uninstall: 
	rm -rf "$(prefix)$(OCAML_SITELIB)/bytes"

# install-self and uninstall-self use ocamlfind already. This is a bit
# questionable here.

install-self: all
	cd _build/ && ocamlfind install bytes ../META $(BYTE_FILES) -optional $(NATIVE_FILES) $(NATIVE_FILES_DYNLINK)

uninstall-self:
	ocamlfind remove bytes

clean:
	ocamlbuild -clean

=== src/findlib/Makefile ===
# make all: compile to bytecode
# make opt: compile to native code
# make install: install bytecode and/or native code
#
# See Makefile.config for configurable variables.
# Runtime configurations might also be necessary in the site-lib/*/META
# files.
#----------------------------------------------------------------------

TOP=../..
include $(TOP)/Makefile.config

NAME = findlib

# Need compiler-libs since ocaml-4.00
OCAMLC = ocamlc -I +compiler-libs
OCAMLOPT = ocamlopt -I +compiler-libs
OCAMLDEP = ocamldep
OCAMLLEX = ocamllex
#CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
#CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_dump.cmo --


OBJECTS        = findlib_config.cmo fl_split.cmo fl_metatoken.cmo fl_meta.cmo \
		 fl_metascanner.cmo fl_topo.cmo fl_package_base.cmo \
	         findlib.cmo fl_args.cmo
TOBJECTS       = topfind.cmo

XOBJECTS       = $(OBJECTS:.cmo=.cmx)

OCAMLFIND_OBJECTS = ocaml_args.cmo frontend.cmo
OCAMLFIND_XOBJECTS = ocaml_args.cmx frontend.cmx

NUMTOP_OBJECTS = num_top_printers.cmo num_top.cmo

all: ocamlfind$(EXEC_SUFFIX) findlib.cma findlib_top.cma topfind num_top.cma

opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa topfind

ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
	$(OCAMLC) $(CUSTOM) -o ocamlfind$(EXEC_SUFFIX) -g findlib.cma unix.cma \
	          $(OCAMLC_FLAGS) $(OCAMLFIND_OBJECTS)

ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa $(OCAMLFIND_XOBJECTS)
	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
		  $(OCAMLOPT_FLAGS) $(OCAMLFIND_XOBJECTS)

test_parser$(EXEC_SUFFIX): fl_metascanner.cmx test_parser.cmx fl_metatoken.cmx fl_meta.cmx
	$(OCAMLOPT) -o test_parser$(EXEC_SUFFIX) fl_meta.cmx fl_metatoken.cmx fl_metascanner.cmx test_parser.cmx

findlib.cma: $(OBJECTS)
	$(OCAMLC) -a -o findlib.cma $(OBJECTS)

findlib_top.cma: $(TOBJECTS)
	$(OCAMLC) -a -o findlib_top.cma $(TOBJECTS)

findlib.cmxa: $(XOBJECTS)
	$(OCAMLOPT) -a -o findlib.cmxa $(XOBJECTS)
	if [ $(HAVE_NATDYNLINK) -gt 0 ]; then \
	    $(OCAMLOPT) -shared -o findlib.cmxs $(XOBJECTS); \
	fi

findlib_config.ml: findlib_config.mlp $(TOP)/Makefile.config
	USE_CYGPATH="$(USE_CYGPATH)"; \
	export USE_CYGPATH; \
	cat findlib_config.mlp | \
		$(TOP)/tools/patch '@CONFIGFILE@' '$(OCAMLFIND_CONF)' | \
		$(TOP)/tools/patch '@STDLIB@' '$(OCAML_CORE_STDLIB)' | \
		sed -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
		    -e 's;@SYSTEM@;$(SYSTEM);g' \
		     >findlib_config.ml

topfind.ml: topfind.ml.in
	if [ "$(ENABLE_TOPFIND_PPXOPT)" = "true" ]; then                 \
		cp topfind.ml.in topfind.ml;                             \
	else                                                             \
		sed -e '/PPXOPT_BEGIN/,/PPXOPT_END/ d' topfind.ml.in     \
			> topfind.ml ;                                   \
	fi

topfind.cmo: topfind.cmi
topfind.cmx: topfind.cmi

topfind: topfind_rd$(OCAML_REMOVE_DIRECTORY).p
	USE_CYGPATH="$(USE_CYGPATH)"; \
	export USE_CYGPATH; \
	cat topfind_rd$(OCAML_REMOVE_DIRECTORY).p | \
		$(TOP)/tools/patch '@SITELIB@' '$(OCAML_SITELIB)' \
	    	    >topfind

num_top.cma: $(NUMTOP_OBJECTS)
	$(OCAMLC) -a -o num_top.cma $(NUMTOP_OBJECTS)

clean:
	rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa \
	  fl_meta.ml findlib_config.ml findlib.mml topfind.ml topfind \
	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)

install: all
	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib.cmxa findlib.a findlib.cmxs META` && \
	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
	# the following "if" block is only needed for 4.00beta2
	if [ $(OCAML_REMOVE_DIRECTORY) -eq 0 -a -f "$(OCAML_CORE_STDLIB)/compiler-libs/topdirs.cmi" ]; then \
	    cd "$(OCAML_CORE_STDLIB)/compiler-libs/"; \
	    cp topdirs.cmi toploop.cmi "$(prefix)$(OCAML_SITELIB)/$(NAME)/"; \
	fi

install-num-top:
	mkdir -p "$(prefix)$(OCAML_SITELIB)/num-top"
	cp num_top.cma num_top.cmi num_top_printers.cmi \
		"$(prefix)$(OCAML_SITELIB)/num-top"

# Note: uninstall-num-top is part of the removal of the META files.

uninstall:
	rm -f $(prefix)$(OCAML_CORE_STDLIB)/findlib
	rm -rf $(prefix)$(OCAML_SITELIB)/$(NAME)
	rm -f $(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)


depend: *.ml *.mli fl_meta.ml fl_metascanner.ml
	$(OCAMLDEP) *.ml *.mli >depend

# Some 'make' implementations require that .SUFFIXES must occur before
# the first suffix rule. (E.g. AIX)
.SUFFIXES: .mll .cmo .cmi .cmx .ml .mli .mml
# .src

.mml.cmo:
	$(OCAMLC) -g -vmthread -c -impl $<

.mml.cmx:
	$(OCAMLOPT) -thread -c -impl $<

.ml.cmx:
	$(OCAMLOPT) -c $<

.ml.cmo:
	$(OCAMLC) -g -c $<

.mli.cmi:
	$(OCAMLC) -c $<

#.src.ml:
#	$(CAMLP4O) -impl $< -o $@

# Solaris make does not like the suffix rule .mll.ml,
# so I replaced it by its single application:
fl_meta.ml: fl_meta.mll
	$(OCAMLLEX) fl_meta.mll

# Don't remove fl_metascanner.ml:
.PRECIOUS: fl_metascanner.ml

include depend

=== debian/changelog ===
findlib (1.5.5-2build1) xenial; urgency=medium

  * Rebuild against bootstrapped ocaml on s390x to fix ocamlfind segfault.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 05 Jan 2016 09:54:00 +0000

findlib (1.5.5-2) unstable; urgency=medium

  * Add `directory' directive to META.bytes
  * Bump debhelper compat level to 9
  * Delete obsolete README.source
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Oct 2015 11:49:01 +0200

findlib (1.5.5-1) experimental; urgency=medium

  * New upstream release
    - compile with OCaml 4.02.1
    - compile without camlp4, drop camlp4 patches
    - compile without labltk, drop wizard
    - install findlib.cmxs
  * Bump Standards-Version to 3.9.6 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 18 Feb 2015 10:10:42 +0100

=== debian/control ===
Source: findlib
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Mehdi Dogguy <mehdi@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 9),
 ocaml-nox (>= 4.02.1),
 ocaml,
 m4,
 gawk | awk,
 dh-ocaml (>= 0.9~)
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/findlib.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/findlib.git
Homepage: http://projects.camlcity.org/projects/findlib.html

Package: ocaml-findlib
Architecture: any
Depends:
 libfindlib-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 camlp4
Recommends: libfindlib-ocaml-dev
Provides: ${ocaml:Provides}
Description: management tool for OCaml libraries
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains a tool (ocamlfind) that allows the user to
 enter queries on the command-line. In order to simplify compilation
 and linkage, there are new frontends, all driven by ocamlfind, for
 the various OCaml compilers that can directly deal with packages.

Package: libfindlib-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: ocaml-findlib
Provides: ${ocaml:Provides}
Replaces: ocaml-findlib (<< 1.2.4-3)
Breaks: ocaml-findlib (<< 1.2.4-3)
Description: library for managing OCaml libraries (development files)
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains development files needed to compile programs
 using findlib.

Package: libfindlib-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Replaces: ocaml-findlib (<< 1.2.4-3)
Breaks: ocaml-findlib (<< 1.2.4-3)
Description: library for managing OCaml libraries (runtime)
 The "findlib" OCaml library provides a scheme to manage reusable
 software components (packages), and includes tools that support this
 scheme. Packages are collections of OCaml modules for which
 metainformation can be stored. The packages are kept in the
 filesystem hierarchy, but with strict directory structure. The
 library contains functions to look the directory up that stores a
 package, to query metainformation about a package, and to retrieve
 dependency information about multiple packages.
 .
 This package contains files that are or may be needed at runtime by
 programs using findlib (META files and dynamically-loadable files).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure \
		-config /etc/ocamlfind.conf \
		-bindir /usr/bin \
		-sitelib $(OCAML_STDLIB_DIR) \
		-mandir /usr/share/man \
		-no-camlp4 \
		-with-toolbox

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE)
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	$(MAKE) opt
endif

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install prefix=$(CURDIR)/debian/tmp
# rm ocamlc.opt and similar settings, they're not avail everywhere in debian
	grep -v \\.opt debian/tmp/etc/ocamlfind.conf > debian/ocamlfind.conf.new
	sed -i -e 's/@OCamlABI@/$(OCAML_ABI)/g' debian/ocamlfind.conf.new
	mv debian/ocamlfind.conf.new debian/tmp/etc/ocamlfind.conf
# mv METAs from empty directories to the /META directory
	mkdir -p $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS
	for p in `ls site-lib-src/`; do \
	  mv $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/META \
	    $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS/META.$$p; \
	  rmdir $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/; \
	done
	echo 'directory="^"' >> $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS/META.bytes
# rm empty man3 dir
	test -d $(CURDIR)/debian/tmp/usr/share/man/man3 && \
		rmdir $(CURDIR)/debian/tmp/usr/share/man/man3

# do not strip executables on bytecode executables (is this still needed?)
ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
.PHONY: override_dh_strip
override_dh_strip:
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	if [ -f Makefile.config ]; then $(MAKE) clean; fi
	-find . -name META -delete
	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
	-rm -Rf site-lib-src/camlp4/

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

=== debian/watch ===
version=3
opts=dversionmangle=s/\+debian\d*$//,uversionmangle=s/&#48\x3b/0/g \
http://download.camlcity.org/download/findlib-(\d+\..*)\.tar\.gz

## findlib 1.6.2

=== Makefile ===
--- 
+++ 
@@ -71,26 +71,26 @@
 
 .PHONY: install-doc
 install-doc:
-	mkdir -p $(prefix)$(OCAMLFIND_MAN)/man1 $(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5
-	-cp doc/ref-man/ocamlfind.1 $(prefix)$(OCAMLFIND_MAN)/man1
-	-cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 $(prefix)$(OCAMLFIND_MAN)/man5
+	mkdir -p "$(prefix)$(OCAMLFIND_MAN)/man1" "$(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5"
+	-cp doc/ref-man/ocamlfind.1 "$(prefix)$(OCAMLFIND_MAN)/man1"
+	-cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 "$(prefix)$(OCAMLFIND_MAN)/man5"
 
 .PHONY: uninstall-doc
 uninstall-doc:
-	rm -f $(prefix)$(OCAMLFIND_MAN)/man1/ocamlfind.1
-	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Findlib.3
-	rm -f $(prefix)$(OCAMLFIND_MAN)/man3/Topfind.3
-	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/META.5
-	rm -f $(prefix)$(OCAMLFIND_MAN)/man5/site-lib.5
+	rm -f "$(prefix)$(OCAMLFIND_MAN)/man1/ocamlfind.1"
+	rm -f "$(prefix)$(OCAMLFIND_MAN)/man3/Findlib.3"
+	rm -f "$(prefix)$(OCAMLFIND_MAN)/man3/Topfind.3"
+	rm -f "$(prefix)$(OCAMLFIND_MAN)/man5/META.5"
+	rm -f "$(prefix)$(OCAMLFIND_MAN)/man5/site-lib.5"
 
 
 .PHONY: install-meta
 install-meta:
-	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" -a -f "site-lib-src/$$x/META" ]; then mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
+	for x in `ls site-lib-src`; do if [ -f "site-lib-src/$$x/META" ]; then mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
 
 .PHONY: uninstall-meta
 uninstall-meta:
-	for x in `ls site-lib-src`; do if [ "$$x" != "CVS" ]; then rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
+	for x in `ls site-lib-src`; do if [ -f "site-lib-src/$$x/META" ]; then rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
 
 .PHONY: install-config
 install-config:

=== debian/changelog ===
findlib (1.6.2-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.8

 -- Stéphane Glondu <glondu@debian.org>  Thu, 09 Jun 2016 13:04:26 +0200

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
  m4,
  gawk | awk,
  dh-ocaml (>= 0.9~)
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/findlib.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/findlib.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
 Homepage: http://projects.camlcity.org/projects/findlib.html
 
 Package: ocaml-findlib

=== debian/rules ===
--- 
+++ 
@@ -33,14 +33,6 @@
 	grep -v \\.opt debian/tmp/etc/ocamlfind.conf > debian/ocamlfind.conf.new
 	sed -i -e 's/@OCamlABI@/$(OCAML_ABI)/g' debian/ocamlfind.conf.new
 	mv debian/ocamlfind.conf.new debian/tmp/etc/ocamlfind.conf
-# mv METAs from empty directories to the /META directory
-	mkdir -p $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS
-	for p in `ls site-lib-src/`; do \
-	  mv $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/META \
-	    $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS/META.$$p; \
-	  rmdir $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/$$p/; \
-	done
-	echo 'directory="^"' >> $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/METAS/META.bytes
 # rm empty man3 dir
 	test -d $(CURDIR)/debian/tmp/usr/share/man/man3 && \
 		rmdir $(CURDIR)/debian/tmp/usr/share/man/man3
@@ -54,7 +46,6 @@
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
 	if [ -f Makefile.config ]; then $(MAKE) clean; fi
-	-find . -name META -delete
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
 	-rm -Rf site-lib-src/camlp4/

## findlib 1.7.1

=== debian/changelog ===
findlib (1.7.1-2) experimental; urgency=medium

  * Fix build on non-dynlink arches.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Mar 2017 00:07:03 +0100

findlib (1.7.1-1) experimental; urgency=medium

  * Add myself to Uploaders.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Mar 2017 15:36:40 +0100

findlib (1.6.3-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Thu, 20 Oct 2016 18:56:58 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,12 @@
 Uploaders:
  Mehdi Dogguy <mehdi@debian.org>,
  Stéphane Glondu <glondu@debian.org>,
- Nicolas Dandrimont <nicolas.dandrimont@crans.org>
+ Nicolas Dandrimont <nicolas.dandrimont@crans.org>,
+ Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper (>= 9),
- ocaml-nox (>= 4.02.1),
+ bash-completion,
+ ocaml-nox (>= 4.03.0),
  ocaml,
  m4,
  gawk | awk,

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 include /usr/share/ocaml/ocamlvars.mk
 
 %:
-	dh $@ --with ocaml
+	dh $@ --with ocaml,bash-completion
 
 .PHONY: override_dh_auto_configure
 override_dh_auto_configure:
@@ -25,6 +25,14 @@
 ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
 	$(MAKE) opt
 endif
+
+ifeq ($(DEB_BUILD_ARCH_BITS),64)
+  OCAMLINIT_SED += -e 's/^64: //'
+else
+  OCAMLINIT_SED += -e '/^64: /d'
+endif
+
+export OCAMLINIT_SED
 
 .PHONY: override_dh_auto_install
 override_dh_auto_install:
@@ -51,4 +59,4 @@
 
 .PHONY: override_dh_install
 override_dh_install:
-	dh_install --fail-missing
+	dh_install --fail-missing -Xocamlbuild/META

## findlib 1.7.3

=== src/findlib/Makefile ===
--- 
+++ 
@@ -23,19 +23,28 @@
 
 OBJECTS        = findlib_config.cmo fl_split.cmo fl_metatoken.cmo fl_meta.cmo \
 		 fl_metascanner.cmo fl_topo.cmo fl_package_base.cmo \
-	         findlib.cmo fl_args.cmo
+	         findlib.cmo fl_args.cmo fl_lint.cmo
 TOBJECTS       = topfind.cmo
 
 XOBJECTS       = $(OBJECTS:.cmo=.cmx)
+TXOBJECTS      = topfind.cmx
 
 OCAMLFIND_OBJECTS = ocaml_args.cmo frontend.cmo
 OCAMLFIND_XOBJECTS = ocaml_args.cmx frontend.cmx
 
 NUMTOP_OBJECTS = num_top_printers.cmo num_top.cmo
 
-all: ocamlfind$(EXEC_SUFFIX) findlib.cma findlib_top.cma topfind num_top.cma
+DYNLOAD_OBJECTS  = fl_dynload.cmo
+DYNLOAD_XOBJECTS = $(DYNLOAD_OBJECTS:.cmo=.cmx)
 
-opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa topfind
+
+all: ocamlfind$(EXEC_SUFFIX) findlib.cma findlib_top.cma topfind $(NUMTOP) \
+     findlib_dynload.cma
+
+opt: ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa findlib_top.cmxa topfind \
+     findlib_dynload.cmxa
+
+num-top: num_top.cma
 
 ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
 	$(OCAMLC) $(CUSTOM) -o ocamlfind$(EXEC_SUFFIX) -g findlib.cma unix.cma \
@@ -60,12 +69,27 @@
 	    $(OCAMLOPT) -shared -o findlib.cmxs $(XOBJECTS); \
 	fi
 
+findlib_top.cmxa: $(TXOBJECTS)
+	$(OCAMLOPT) -a -o findlib_top.cmxa $(TXOBJECTS)
+	if [ $(HAVE_NATDYNLINK) -gt 0 ]; then \
+	    $(OCAMLOPT) -shared -o findlib_top.cmxs $(TXOBJECTS); \
+	fi
+
+findlib_dynload.cma: $(DYNLOAD_OBJECTS)
+	$(OCAMLC) -a -o findlib_dynload.cma $(DYNLOAD_OBJECTS)
+
+findlib_dynload.cmxa: $(DYNLOAD_XOBJECTS)
+	$(OCAMLOPT) -a -o findlib_dynload.cmxa $(DYNLOAD_XOBJECTS)
+	if [ $(HAVE_NATDYNLINK) -gt 0 ]; then \
+	    $(OCAMLOPT) -shared -o findlib_dynload.cmxs $(DYNLOAD_XOBJECTS); \
+	fi
+
 findlib_config.ml: findlib_config.mlp $(TOP)/Makefile.config
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
 	cat findlib_config.mlp | \
-		$(TOP)/tools/patch '@CONFIGFILE@' '$(OCAMLFIND_CONF)' | \
-		$(TOP)/tools/patch '@STDLIB@' '$(OCAML_CORE_STDLIB)' | \
+	        $(SH) $(TOP)/tools/patch '@CONFIGFILE@' '$(OCAMLFIND_CONF)' | \
+	        $(SH) $(TOP)/tools/patch '@STDLIB@' '$(OCAML_CORE_STDLIB)' | \
 		sed -e 's;@AUTOLINK@;$(OCAML_AUTOLINK);g' \
 		    -e 's;@SYSTEM@;$(SYSTEM);g' \
 		     >findlib_config.ml
@@ -85,7 +109,7 @@
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
 	cat topfind_rd$(OCAML_REMOVE_DIRECTORY).p | \
-		$(TOP)/tools/patch '@SITELIB@' '$(OCAML_SITELIB)' \
+	        $(SH) $(TOP)/tools/patch '@SITELIB@' '$(OCAML_SITELIB)' \
 	    	    >topfind
 
 num_top.cma: $(NUMTOP_OBJECTS)
@@ -100,7 +124,7 @@
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
 	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
-	files=`$(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib.cmxa findlib.a findlib.cmxs META` && \
+	files=`$(SH) $(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma findlib.cmxa findlib.a findlib.cmxs topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib_top.cmxa findlib_top.a findlib_top.cmxs findlib_dynload.cma findlib_dynload.cmxa findlib_dynload.a findlib_dynload.cmxs fl_dynload.mli fl_dynload.cmi META` && \
 	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
 	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
@@ -132,19 +156,19 @@
 # .src
 
 .mml.cmo:
-	$(OCAMLC) -g -vmthread -c -impl $<
+	$(OCAMLC) $(OPAQUE) -g -vmthread -c -impl $<
 
 .mml.cmx:
-	$(OCAMLOPT) -thread -c -impl $<
+	$(OCAMLOPT) $(OPAQUE) -thread -c -impl $<
 
 .ml.cmx:
-	$(OCAMLOPT) -c $<
+	$(OCAMLOPT) $(OPAQUE) -c $<
 
 .ml.cmo:
-	$(OCAMLC) -g -c $<
+	$(OCAMLC) $(OPAQUE) -g -c $<
 
 .mli.cmi:
-	$(OCAMLC) -c $<
+	$(OCAMLC) $(OPAQUE) -c $<
 
 #.src.ml:
 #	$(CAMLP4O) -impl $< -o $@

=== debian/changelog ===
findlib (1.7.3-2) unstable; urgency=medium

  * Upload to unstable.
  * Remove Nicolas Dandrimont from Uploaders as requested by him.

 -- Ximin Luo <infinity0@debian.org>  Sat, 16 Sep 2017 13:54:42 +0200

findlib (1.7.3-1) experimental; urgency=medium

  * New upstream release.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Sat, 29 Jul 2017 16:09:53 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
 Uploaders:
  Mehdi Dogguy <mehdi@debian.org>,
  Stéphane Glondu <glondu@debian.org>,
- Nicolas Dandrimont <nicolas.dandrimont@crans.org>,
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
  debhelper (>= 9),
@@ -15,7 +14,7 @@
  m4,
  gawk | awk,
  dh-ocaml (>= 0.9~)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
 Homepage: http://projects.camlcity.org/projects/findlib.html

=== debian/rules ===
--- 
+++ 
@@ -26,10 +26,9 @@
 	$(MAKE) opt
 endif
 
-ifeq ($(DEB_BUILD_ARCH_BITS),64)
-  OCAMLINIT_SED += -e 's/^64: //'
-else
-  OCAMLINIT_SED += -e '/^64: /d'
+# Some platforms don't have raw_spacetime, do the same check as ./configure
+ifeq (,$(wildcard $(OCAML_STDLIB_DIR)/raw_spacetime_lib.cmxa))
+  OCAMLINIT_SED += -e '\,raw_spacetime/META,d'
 endif
 
 export OCAMLINIT_SED

=== debian/watch ===
version=3
opts=dversionmangle=s/\+debian\d*$//,uversionmangle=s/&#48\x3b/0/g \
http://download.camlcity.org/download/findlib-(\d+\..*)\.tar\.gz
# TODO: the git version below is better: it's available over HTTPS and does not
# contain pre-build documentation that exists in the release tarball. In Debian
# we are *supposed* to rebuild this documentation, but that requires a load of
# extra build dependencies, some of which aren't in Debian atm. The original
# packager should have done this; and I don't have time for that atm, I just
# want to upgrade the OCaml compiler.
#version=4
#opts=filenamemangle=s/.*ref=@PACKAGE@-(.*)$/@PACKAGE@-$1.tar.gz/ \
#https://gitlab.camlcity.org/gerd/lib-findlib/tags .*/archive.tar.gz\?ref=@PACKAGE@-(.*)

## findlib 1.8.1

=== src/findlib/Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 # Need compiler-libs since ocaml-4.00
 OCAMLC = ocamlc -I +compiler-libs
-OCAMLOPT = ocamlopt -I +compiler-libs
+OCAMLOPT = ocamlopt -I +compiler-libs -g
 OCAMLDEP = ocamldep
 OCAMLLEX = ocamllex
 #CAMLP4O =  camlp4 pa_o.cmo pa_op.cmo pr_o.cmo --
@@ -102,9 +102,6 @@
 			> topfind.ml ;                                   \
 	fi
 
-topfind.cmo: topfind.cmi
-topfind.cmx: topfind.cmi
-
 topfind: topfind_rd$(OCAML_REMOVE_DIRECTORY).p
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
@@ -116,7 +113,7 @@
 	$(OCAMLC) -a -o num_top.cma $(NUMTOP_OBJECTS)
 
 clean:
-	rm -f *.cmi *.cmo *.cma *.cmx *.a *.o *.cmxa \
+	rm -f *.cmi *.cmo *.cma *.cmx *.a *.lib *.o *.obj *.cmxa \
 	  fl_meta.ml findlib_config.ml findlib.mml topfind.ml topfind \
 	  ocamlfind$(EXEC_SUFFIX) ocamlfind_opt$(EXEC_SUFFIX)
 
@@ -124,7 +121,7 @@
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
 	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
-	files=`$(SH) $(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma findlib.cmxa findlib.a findlib.cmxs topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib_top.cmxa findlib_top.a findlib_top.cmxs findlib_dynload.cma findlib_dynload.cmxa findlib_dynload.a findlib_dynload.cmxs fl_dynload.mli fl_dynload.cmi META` && \
+	files=`$(SH) $(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma findlib.cmxa findlib$(LIB_SUFFIX) findlib.cmxs topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib_top.cmxa findlib_top$(LIB_SUFFIX) findlib_top.cmxs findlib_dynload.cma findlib_dynload.cmxa findlib_dynload$(LIB_SUFFIX) findlib_dynload.cmxs fl_dynload.mli fl_dynload.cmi META` && \
 	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
 	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
@@ -147,7 +144,7 @@
 	rm -f $(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)
 
 
-depend: *.ml *.mli fl_meta.ml fl_metascanner.ml
+depend: *.ml *.mli fl_meta.ml fl_metascanner.ml findlib_config.ml topfind.ml
 	$(OCAMLDEP) *.ml *.mli >depend
 
 # Some 'make' implementations require that .SUFFIXES must occur before

=== debian/changelog ===
findlib (1.8.1-1build3) focal; urgency=medium

  * No-change rebuild against OCaml 4.08.

 -- Logan Rosen <logan@ubuntu.com>  Fri, 14 Feb 2020 22:41:27 -0500

findlib (1.8.1-1build2) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Sep 2019 11:42:43 +0200

findlib (1.8.1-1build1) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Aug 2019 13:02:21 +0200

findlib (1.8.1-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat level to 12

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Aug 2019 05:12:17 +0200

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,16 @@
  Stéphane Glondu <glondu@debian.org>,
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 12),
  bash-completion,
  ocaml-nox (>= 4.03.0),
  ocaml,
  m4,
  gawk | awk,
  dh-ocaml (>= 0.9~)
-Standards-Version: 4.0.0
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/findlib.git
+Standards-Version: 4.4.0
+Vcs-Git: https://salsa.debian.org/ocaml-team/findlib.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/findlib
 Homepage: http://projects.camlcity.org/projects/findlib.html
 
 Package: ocaml-findlib

=== debian/rules ===
--- 
+++ 
@@ -56,6 +56,14 @@
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
 	-rm -Rf site-lib-src/camlp4/
 
-.PHONY: override_dh_install
+override_dh_missing:
+	dh_missing --fail-missing
+
+override_dh_dwz:
+
 override_dh_install:
-	dh_install --fail-missing -Xocamlbuild/META
+# temporary hack to make the package work with both OCaml 4.05.0 and 4.08.0
+	if ! [ -f $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/num/META ]; then \
+	  sed -i /num/d debian/*.install; \
+	fi
+	dh_install

## findlib 1.9.1

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 #----------------------------------------------------------------------
 
 include Makefile.config
+-include Makefile.packages
 
 TOP=.
 
@@ -16,19 +17,17 @@
 opt:
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) opt ) || exit; done
 
-install:
+install: check-installation
 	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
 	mkdir -p "$(prefix)$(OCAMLFIND_MAN)"
 	$(MAKE) install-config
 	for p in $(PARTS); do ( cd src/$$p; $(MAKE) install ); done
 	$(MAKE) install-meta
-	cd src/findlib; $(MAKE) install-num-top
-	if [ $(INSTALL_CAMLP4) -eq 1 ]; then \
-		cp tools/safe_camlp4 "$(prefix)$(OCAMLFIND_BIN)"; \
-	fi
+	test ! -f 'site-lib-src/num-top/META' || { cd src/findlib; $(MAKE) install-num-top; }
+	test ! -f 'site-lib-src/camlp4/META' ||	cp tools/safe_camlp4 "$(prefix)$(OCAMLFIND_BIN)"
 	$(MAKE) install-doc
 
-uninstall:
+uninstall: check-installation
 	$(MAKE) uninstall-doc
 	$(MAKE) uninstall-meta
 	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) uninstall ); done
@@ -38,7 +37,7 @@
 	for p in `cd src; echo *`; do ( cd src/$$p; $(MAKE) clean ); done
 	(cd itest-aux; $(MAKE) clean)
 	(cd tools/extract_args; $(MAKE) clean)
-	rm -f findlib.conf
+	rm -f findlib.conf Makefile.packages
 
 .PHONY: release
 release: README
@@ -55,23 +54,23 @@
 	USE_CYGPATH="$(USE_CYGPATH)"; \
 	export USE_CYGPATH; \
 	cat findlib.conf.in | \
-		tools/patch '@SITELIB@' '$(OCAML_SITELIB)' >findlib.conf
-	if ocamlc.opt >/dev/null 2>&1; then \
+	    $(SH) tools/patch '@SITELIB@' '$(OCAML_SITELIB)' >findlib.conf
+	if ./tools/cmd_from_same_dir ocamlc; then \
 		echo 'ocamlc="ocamlc.opt"' >>findlib.conf; \
 	fi
-	if ocamlopt.opt >/dev/null 2>&1; then \
+	if ./tools/cmd_from_same_dir ocamlopt; then \
 		echo 'ocamlopt="ocamlopt.opt"' >>findlib.conf; \
 	fi
-	if ocamldep.opt >/dev/null 2>&1; then \
+	if ./tools/cmd_from_same_dir ocamldep; then \
 		echo 'ocamldep="ocamldep.opt"' >>findlib.conf; \
 	fi
-	if ocamldoc.opt >/dev/null 2>&1; then \
+	if ./tools/cmd_from_same_dir ocamldoc; then \
 		echo 'ocamldoc="ocamldoc.opt"' >>findlib.conf; \
 	fi
 
 .PHONY: install-doc
 install-doc:
-	mkdir -p "$(prefix)$(OCAMLFIND_MAN)/man1" "$(prefix)$(OCAMLFIND_MAN)/man3 $(prefix)$(OCAMLFIND_MAN)/man5"
+	mkdir -p "$(prefix)$(OCAMLFIND_MAN)/man1" "$(prefix)$(OCAMLFIND_MAN)/man3" "$(prefix)$(OCAMLFIND_MAN)/man5"
 	-cp doc/ref-man/ocamlfind.1 "$(prefix)$(OCAMLFIND_MAN)/man1"
 	-cp doc/ref-man/META.5 doc/ref-man/site-lib.5 doc/ref-man/findlib.conf.5 "$(prefix)$(OCAMLFIND_MAN)/man5"
 
@@ -84,13 +83,31 @@
 	rm -f "$(prefix)$(OCAMLFIND_MAN)/man5/site-lib.5"
 
 
+.PHONY: check-installation
+check-installation:
+	if [ "$(CHECK_BEFORE_INSTALL)" -eq 1 ]; then \
+    for x in camlp4 dbm graphics labltk num ocamlbuild; do \
+      if [ -f "$(prefix)$(OCAML_SITELIB)/$$x/META" ]; then \
+        if ! grep -Fq '[distributed with Ocaml]' "$(prefix)/$(OCAML_SITELIB)/$$x/META"; then \
+          rm -f site-lib-src/$$x/META; \
+        fi \
+      fi \
+    done; \
+    test -f "site-lib-src/num/META" || rm -f "site-lib-src/num-top/META"; \
+  fi
+	echo 'SITELIB_META =' > Makefile.packages.in
+	for x in `ls site-lib-src`; do test ! -f "site-lib-src/$$x/META" || echo $$x >> Makefile.packages.in; done
+	tr '\n' ' ' < Makefile.packages.in > Makefile.packages
+	rm Makefile.packages.in
+
 .PHONY: install-meta
 install-meta:
-	for x in `ls site-lib-src`; do if [ -f "site-lib-src/$$x/META" ]; then mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
+	for x in $(SITELIB_META); do mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; done
+	mkdir -p "$(prefix)$(OCAML_SITELIB)/findlib"; cp Makefile.packages "$(prefix)$(OCAML_SITELIB)/findlib/Makefile.packages"
 
 .PHONY: uninstall-meta
 uninstall-meta:
-	for x in `ls site-lib-src`; do if [ -f "site-lib-src/$$x/META" ]; then rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; fi; done
+	for x in $(SITELIB_META); do rm -rf "$(prefix)$(OCAML_SITELIB)/$$x"; done
 
 .PHONY: install-config
 install-config:

=== debian/changelog ===
findlib (1.9.1-1build2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes (riscv64).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jan 2022 11:35:06 +0100

findlib (1.9.1-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:19:40 +0100

findlib (1.9.1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Bump debian/watch version to 4

 -- Stéphane Glondu <glondu@debian.org>  Wed, 15 Dec 2021 08:15:55 +0100

findlib (1.8.1-2) unstable; urgency=medium

  * Cope with OCaml 4.11.1 not installing graphics any more
  * Remove patches no longer relevant as of OCaml 4.11.0
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Tue, 13 Oct 2020 07:21:46 +0200

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,14 @@
  Stéphane Glondu <glondu@debian.org>,
  Ximin Luo <infinity0@debian.org>
 Build-Depends:
- debhelper (>= 12),
+ debhelper-compat (= 13),
  bash-completion,
- ocaml-nox (>= 4.03.0),
+ ocaml-nox (>= 4.11.1),
  ocaml,
- m4,
  gawk | awk,
- dh-ocaml (>= 0.9~)
-Standards-Version: 4.4.0
+ dh-ocaml
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/findlib.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/findlib
 Homepage: http://projects.camlcity.org/projects/findlib.html

=== debian/rules ===
--- 
+++ 
@@ -55,15 +55,3 @@
 	if [ -f Makefile.config ]; then $(MAKE) clean; fi
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
 	-rm -Rf site-lib-src/camlp4/
-
-override_dh_missing:
-	dh_missing --fail-missing
-
-override_dh_dwz:
-
-override_dh_install:
-# temporary hack to make the package work with both OCaml 4.05.0 and 4.08.0
-	if ! [ -f $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/num/META ]; then \
-	  sed -i /num/d debian/*.install; \
-	fi
-	dh_install

## findlib 1.9.3

=== Makefile ===
--- 
+++ 
@@ -90,8 +90,8 @@
       if [ -f "$(prefix)$(OCAML_SITELIB)/$$x/META" ]; then \
         if ! grep -Fq '[distributed with Ocaml]' "$(prefix)/$(OCAML_SITELIB)/$$x/META"; then \
           rm -f site-lib-src/$$x/META; \
-        fi \
-      fi \
+        fi; \
+      fi; \
     done; \
     test -f "site-lib-src/num/META" || rm -f "site-lib-src/num-top/META"; \
   fi
@@ -102,7 +102,7 @@
 
 .PHONY: install-meta
 install-meta:
-	for x in $(SITELIB_META); do mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x"; done
+	for x in $(SITELIB_META); do mkdir -p "$(prefix)$(OCAML_SITELIB)/$$x"; cp site-lib-src/$$x/META "$(prefix)$(OCAML_SITELIB)/$$x/META.tmp" && mv "$(prefix)$(OCAML_SITELIB)/$$x/META.tmp" "$(prefix)$(OCAML_SITELIB)/$$x/META"; done
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/findlib"; cp Makefile.packages "$(prefix)$(OCAML_SITELIB)/findlib/Makefile.packages"
 
 .PHONY: uninstall-meta

=== src/bytes/Makefile ===
BYTE_FILES=bytes.cmi bytes.cma
NATIVE_FILES=bytes.cmx bytes$(LIB_SUFFIX) bytes.cmxa
NATIVE_FILES_DYNLINK=bytes.cmxs

TOP=../..
include $(TOP)/Makefile.config

OCAMLC = ocamlc
OCAMLOPT = ocamlopt -g

build: all opt

all:
	$(OCAMLC) -a -o bytes.cma bytes.ml

opt:
	$(OCAMLOPT) -a -o bytes.cmxa bytes.ml
	if [ $(HAVE_NATDYNLINK) -gt 0 ]; then \
	    $(OCAMLOPT) -shared -o bytes.cmxs bytes.cmxa; \
	fi

install: all
	mkdir -p "$(prefix)$(OCAML_SITELIB)/bytes"
	cp META $(BYTE_FILES) "$(prefix)$(OCAML_SITELIB)/bytes"
	for f in $(NATIVE_FILES) $(NATIVE_FILES_DYNLINK); do if [ -f "$$f" ]; then cp $$f "$(prefix)$(OCAML_SITELIB)/bytes"; fi; done

uninstall: 
	rm -rf "$(prefix)$(OCAML_SITELIB)/bytes"

# install-self and uninstall-self use ocamlfind already. This is a bit
# questionable here.

install-self: all
	ocamlfind install bytes META $(BYTE_FILES) -optional $(NATIVE_FILES) $(NATIVE_FILES_DYNLINK)

uninstall-self:
	ocamlfind remove bytes

clean:
	ocamlbuild -clean

=== src/findlib/Makefile ===
--- 
+++ 
@@ -32,6 +32,9 @@
 OCAMLFIND_OBJECTS = ocaml_args.cmo frontend.cmo
 OCAMLFIND_XOBJECTS = ocaml_args.cmx frontend.cmx
 
+# OCAMLFIND_ARCHIVES: set in Makefile.config
+OCAMLFIND_XARCHIVES = $(OCAMLFIND_ARCHIVES:.cma=.cmxa)
+
 NUMTOP_OBJECTS = num_top_printers.cmo num_top.cmo
 
 DYNLOAD_OBJECTS  = fl_dynload.cmo
@@ -47,12 +50,12 @@
 num-top: num_top.cma
 
 ocamlfind$(EXEC_SUFFIX): findlib.cma $(OCAMLFIND_OBJECTS)
-	$(OCAMLC) $(CUSTOM) -o ocamlfind$(EXEC_SUFFIX) -g findlib.cma unix.cma \
-	          $(OCAMLC_FLAGS) $(OCAMLFIND_OBJECTS)
+	$(OCAMLC) $(CUSTOM) -o ocamlfind$(EXEC_SUFFIX) -g $(OCAMLFIND_ARCHIVES) \
+	          $(OCAMLC_FLAGS) $(OCAMLFIND_OCAMLFLAGS) $(OCAMLFIND_OBJECTS)
 
 ocamlfind_opt$(EXEC_SUFFIX): findlib.cmxa $(OCAMLFIND_XOBJECTS)
-	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) findlib.cmxa unix.cmxa \
-		  $(OCAMLOPT_FLAGS) $(OCAMLFIND_XOBJECTS)
+	$(OCAMLOPT) -o ocamlfind_opt$(EXEC_SUFFIX) $(OCAMLFIND_XARCHIVES) \
+		  $(OCAMLOPT_FLAGS) $(OCAMLFIND_OCAMLFLAGS) $(OCAMLFIND_XOBJECTS)
 
 test_parser$(EXEC_SUFFIX): fl_metascanner.cmx test_parser.cmx fl_metatoken.cmx fl_meta.cmx
 	$(OCAMLOPT) -o test_parser$(EXEC_SUFFIX) fl_meta.cmx fl_metatoken.cmx fl_metascanner.cmx test_parser.cmx
@@ -121,7 +124,14 @@
 	mkdir -p "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	mkdir -p "$(prefix)$(OCAMLFIND_BIN)"
 	test $(INSTALL_TOPFIND) -eq 0 || cp topfind "$(prefix)$(OCAML_CORE_STDLIB)"
-	files=`$(SH) $(TOP)/tools/collect_files $(TOP)/Makefile.config findlib.cmi findlib.mli findlib.cma findlib.cmxa findlib$(LIB_SUFFIX) findlib.cmxs topfind.cmi topfind.mli fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi fl_metatoken.cmi findlib_top.cma findlib_top.cmxa findlib_top$(LIB_SUFFIX) findlib_top.cmxs findlib_dynload.cma findlib_dynload.cmxa findlib_dynload$(LIB_SUFFIX) findlib_dynload.cmxs fl_dynload.mli fl_dynload.cmi META` && \
+	files=`$(SH) $(TOP)/tools/collect_files $(TOP)/Makefile.config \
+	findlib.cmi findlib.mli findlib.cma findlib.cmxa findlib$(LIB_SUFFIX) findlib.cmxs \
+	findlib_config.cmi findlib_config.ml topfind.cmi topfind.mli \
+	fl_args.cmi fl_lint.cmi fl_meta.cmi fl_split.cmi fl_topo.cmi ocaml_args.cmi \
+	fl_package_base.mli fl_package_base.cmi fl_metascanner.mli fl_metascanner.cmi \
+	fl_metatoken.cmi findlib_top.cma findlib_top.cmxa findlib_top$(LIB_SUFFIX) findlib_top.cmxs \
+	findlib_dynload.cma findlib_dynload.cmxa findlib_dynload$(LIB_SUFFIX) findlib_dynload.cmxs fl_dynload.mli fl_dynload.cmi \
+	META` && \
 	cp $$files "$(prefix)$(OCAML_SITELIB)/$(NAME)"
 	f="ocamlfind$(EXEC_SUFFIX)"; { test -f ocamlfind_opt$(EXEC_SUFFIX) && f="ocamlfind_opt$(EXEC_SUFFIX)"; }; \
 	cp $$f "$(prefix)$(OCAMLFIND_BIN)/ocamlfind$(EXEC_SUFFIX)"
@@ -153,19 +163,19 @@
 # .src
 
 .mml.cmo:
-	$(OCAMLC) $(OPAQUE) -g -vmthread -c -impl $<
+	$(OCAMLC) $(OPAQUE) $(OCAMLC_FLAGS) $(OCAMLFIND_OCAMLFLAGS) -g -vmthread -c -impl $<
 
 .mml.cmx:
-	$(OCAMLOPT) $(OPAQUE) -thread -c -impl $<
+	$(OCAMLOPT) $(OPAQUE) $(OCAMLOPT_FLAGS) $(OCAMLFIND_OCAMLFLAGS) -thread -c -impl $<
 
 .ml.cmx:
-	$(OCAMLOPT) $(OPAQUE) -c $<
+	$(OCAMLOPT) $(OPAQUE) $(OCAMLOPT_FLAGS) $(OCAMLFIND_OCAMLFLAGS) -c $<
 
 .ml.cmo:
-	$(OCAMLC) $(OPAQUE) -g -c $<
+	$(OCAMLC) $(OPAQUE)  $(OCAMLC_FLAGS) $(OCAMLFIND_OCAMLFLAGS) -g -c $<
 
 .mli.cmi:
-	$(OCAMLC) $(OPAQUE) -c $<
+	$(OCAMLC) $(OPAQUE)  $(OCAMLC_FLAGS) $(OCAMLFIND_OCAMLFLAGS) -c $<
 
 #.src.ml:
 #	$(CAMLP4O) -impl $< -o $@

=== debian/changelog ===
findlib (1.9.3-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 02 Mar 2022 07:41:34 +0100
